#ifndef CSTRING_H
#define CSTRING_H

#include <memory.h>
#include <string.h>

namespace optimized_string
{

class CString
{
public:
	enum 
	{
		DEFAULT_ALLOC_SIZE = 128,
		DEFAULT_GROW_SIZE = 128,
	};

public:
	// constructor / destructor
	CString();
	CString(const CString& Other);
	CString(const char* szString, const size_t& Length);
	~CString();

	// set / reset
	void Reset();
	void Set(const CString& Other);
	void Set(const char* szString, const size_t& Len);

	// basic string functionality
	void Append(const CString& Other, const size_t& Length);
	void Append(const char* szString, const size_t& Length);
	const bool Compare(const CString& Other) const;
	const bool Compare(const char* szString, const size_t& Length) const;
	void LTrim();
	void RTrim();
	size_t Len();
	const size_t Len() const;
	const char* GetCString();
	const char* GetCString() const;

protected:
	void _Allocate(const size_t& Length);
	void _CheckGrow(const size_t& Length, const size_t& CurrentLength);

protected:
	char* m_szPtr;
	size_t m_BufferLength;
};

};

#endif // CSTRING_H